TeamTalk 5 Java DLL Version 5.22A

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | List of all members
BearWare.SpeexDSP Struct Reference
Audio and Video Codecs

Audio configuration specifying how recorded audio from sound input device should be preprocessed before transmission. More...

## Public Member Functions

| SpeexDSP (bool set_defaults)

## Public Attributes

bool | bEnableAGC
| Whether clients who join a BearWare.Channel should enable AGC with the settings specified nGainLevel, nMaxIncDBSec, nMaxDecDBSec and nMaxGainDB.
int | nGainLevel
| A value from 0 to 32768. Default is 8000. Value is ignored if bEnableAGC is FALSE.
int | nMaxIncDBSec
| Used so volume should not be amplified too quickly (maximal gain increase in dB/second). Default is 12.
int | nMaxDecDBSec
| Used so volume should not be attenuated too quickly (maximal gain decrease in dB/second). Negative value! Default is -40. Value is ignored if bEnableAGC is FALSE.
int | nMaxGainDB
| Ensure volume doesn't become too loud (maximal gain in dB). Default is 30. Value is ignored if bEnableAGC is FALSE.
bool | bEnableDenoise
| Whether clients who join the channel should automatically enable denoising.
int | nMaxNoiseSuppressDB
| Maximum attenuation of the noise in dB. Negative value! Default value is -30. Value is ignored if bEnableDenoise is FALSE.
bool | bEnableEchoCancellation
| Speex DSP is used for specifying how recorded audio from a sound input device should be preprocessed before transmission.
int | nEchoSuppress
| Set maximum attenuation of the residual echo in dB (negative number). Default is -40. Value is ignored if bEnableEchoCancellation is FALSE.
int | nEchoSuppressActive
| Set maximum attenuation of the residual echo in dB when near end is active (negative number). Default is -15. Value is ignored if bEnableEchoCancellation is FALSE.

## Detailed Description

Audio configuration specifying how recorded audio from sound input device should be preprocessed before transmission.

Deprecated:
  Use BearWare.WebRTCAudioPreprocessor.

Users' audio levels may be diffent due to how their microphone is configured in their OS. Automatic Gain Control (AGC) can be used to ensure all users in the same channel have the same audio level.

Enable the preprocessing configuration by calling TeamTalkBase.SetSoundInputPreprocess().

When joining a BearWare.Channel and `bEnableGainControl` of BearWare.AudioConfig is enabled in the channel then enable sound input preprocessing by setting `bEnableAGC` to TRUE and `nGainLevel` of BearWare.SpeexDSP to the `nGainLevel` of BearWare.AudioConfig.

Definition at line 1147 of file TeamTalk.cs.

## Constructor & Destructor Documentation

## ◆ SpeexDSP()

BearWare.SpeexDSP.SpeexDSP | ( | bool | set_defaults | ) |

Definition at line 1218 of file TeamTalk.cs.

## Member Data Documentation

## ◆ bEnableAGC

bool BearWare.SpeexDSP.bEnableAGC

Whether clients who join a BearWare.Channel should enable AGC with the settings specified nGainLevel, nMaxIncDBSec, nMaxDecDBSec and nMaxGainDB.

Note that AGC is not supported on ARM (iOS and Android), since there's no fixed point implementation of AGC in SpeexDSP.

Definition at line 1157 of file TeamTalk.cs.

## ◆ nGainLevel

int BearWare.SpeexDSP.nGainLevel

A value from 0 to 32768. Default is 8000. Value is ignored if bEnableAGC is FALSE.

Definition at line 1161 of file TeamTalk.cs.

## ◆ nMaxIncDBSec

int BearWare.SpeexDSP.nMaxIncDBSec

Used so volume should not be amplified too quickly (maximal gain increase in dB/second). Default is 12.

- Value is ignored if bEnableAGC is FALSE.

Definition at line 1166 of file TeamTalk.cs.

## ◆ nMaxDecDBSec

int BearWare.SpeexDSP.nMaxDecDBSec

Used so volume should not be attenuated too quickly (maximal gain decrease in dB/second). Negative value! Default is -40. Value is ignored if bEnableAGC is FALSE.

Definition at line 1172 of file TeamTalk.cs.

## ◆ nMaxGainDB

int BearWare.SpeexDSP.nMaxGainDB

Ensure volume doesn't become too loud (maximal gain in dB). Default is 30. Value is ignored if bEnableAGC is FALSE.

Definition at line 1177 of file TeamTalk.cs.

## ◆ bEnableDenoise

bool BearWare.SpeexDSP.bEnableDenoise

Whether clients who join the channel should automatically enable denoising.

Definition at line 1181 of file TeamTalk.cs.

## ◆ nMaxNoiseSuppressDB

int BearWare.SpeexDSP.nMaxNoiseSuppressDB

Maximum attenuation of the noise in dB. Negative value! Default value is -30. Value is ignored if bEnableDenoise is FALSE.

Definition at line 1186 of file TeamTalk.cs.

## ◆ bEnableEchoCancellation

bool BearWare.SpeexDSP.bEnableEchoCancellation

Speex DSP is used for specifying how recorded audio from a sound input device should be preprocessed before transmission.

In order to enable echo cancellation mode the local client instance must first be set in sound duplex mode by calling TeamTalkBase.InitSoundDuplexDevices(). This is because the echo canceller must first mixed all audio streams into a single stream and have then run in synch with the input stream. After calling TeamTalkBase.InitSoundDuplexDevices() the flag BearWare.ClientFlag.CLIENT_SNDINOUTPUT_DUPLEX will be set.

For echo cancellation to work the sound input and output device must be the same sound card since the input and output stream must be completely synchronized. Also it is recommended to also enable denoising and AGC for better echo cancellation.

See also
  TeamTalkBase.SetSoundInputPreprocess()

Definition at line 1206 of file TeamTalk.cs.

## ◆ nEchoSuppress

int BearWare.SpeexDSP.nEchoSuppress

Set maximum attenuation of the residual echo in dB (negative number). Default is -40. Value is ignored if bEnableEchoCancellation is FALSE.

Definition at line 1211 of file TeamTalk.cs.

## ◆ nEchoSuppressActive

int BearWare.SpeexDSP.nEchoSuppressActive

Set maximum attenuation of the residual echo in dB when near end is active (negative number). Default is -15. Value is ignored if bEnableEchoCancellation is FALSE.

Definition at line 1216 of file TeamTalk.cs.